<template>
  <div class="homePageWrapper">
    <h1 class="logo">
      Clean your damn room, bucko!
    </h1>
    <button v-if="!isExpectLogIn()" class="logInButton" @click="logIn">
      Start cleaning your room with Google account
    </button>
  </div>
</template>

<script>
import { firebase, authProvider } from '~/plugins/firebase'
export default {
  mounted () {
    if (this.isExpectLogIn()) {
      this.showLoadingBar()
    }
    this.registerAuthListener()
  },

  methods: {
    logIn () {
      this.setExpectLogIn(true)
      firebase.auth().signInWithRedirect(authProvider)
    },
    setExpectLogIn (value) {
      localStorage.setItem('expectLogIn', value)
    },
    isExpectLogIn () {
      return localStorage.getItem('expectLogIn') === 'true'
    },
    showLoadingBar () {
      this.$nextTick(() => {
        this.$nuxt.$loading.start()
      })
    },
    registerAuthListener () {
      firebase.auth().onAuthStateChanged((user) => {
        this.setExpectLogIn(false)

        if (user) {
          this.setExpectLogIn(true)
          this.$store.dispatch('logIn', user)
          this.$router.push({ name: 'goals' })
        }
      })
    }
  }
}
</script>

<style scoped>
  .homePageWrapper{
    position: absolute;
    top: 50%; left: 50%;
    transform: translate(-50%, -50%);
    display: flex;
    flex-direction: column;
  }
  .logo {
    @apply text-5xl font-black leading-none mx-auto px-4 mb-10;
    max-width: 200px;
  }
  .logInButton {
    @apply font-bold italic text-xl leading-none text-left;
    max-width: 200px;
  }
</style>
